/* © 2017 Playful Invention Company */


Defs = function() {};

Defs.palette = {
turtle: ['clean', [],['forward', 'back'], ['right', 'left'], 
         'arc', [], 'setxy', 'seth', [],
         'xcor', 'ycor', 'heading'],
pen:	  [['penup', 'pendown'], 'setpensize', 'setcolor', 'setshade', [],
	       ['startfill','endfill'], 'fillscreen', [],
	       'pensize', 'color', 'shade'],
number: ['number', [], ['plus',  'minus'], ['product','division'],
         'remainder', [], 'random', 'oneof', [],
         'greater', 'less' ,'equal', [],
         ['opar', 'cpar'], [], 'print'],
flow:   ['repeat', 'if', 'stop', 'forever', [],'vspace', 'hspace', [], 'wait'],
mystuff: []
}

// [op, svg, docks, <args>]
Defs.blocks = [
 ['clean', 'clean', 'cmd0'],
 ['forward', 'forward', 'cmd',  100],
 ['back', 'back', 'cmd', 100],
 ['right', 'right', 'cmd', 90],
 ['left', 'left', 'cmd', 90],
 ['arc', 'arc', 'cmd2',  [180, 100]],
 ['setxy', 'setxy', 'cmd2', [0, 0]],
 ['seth', 'seth', 'cmd', 0],
 ['xcor', 'xcor', 'input'],
 ['ycor', 'ycor', 'input'],
 ['heading', 'heading', 'input'],

 ['penup', 'penup', 'cmd0'],
 ['pendown', 'pendown', 'cmd0'],
 ['setpensize', 'setpensize', 'cmd', 4],
 ['setcolor', 'setcolor', 'cmd', 0],
 ['setshade', 'setshade', 'cmd',  50],
 ['startfill', 'startfill', 'cmd0'],
 ['endfill', 'endfill', 'cmd0'],
 ['fillscreen', 'fillscreen', 'cmd2', [60, 70]],
 ['pensize', 'pensize', 'input'],
 ['color', 'color', 'input'],
 ['shade', 'shade', 'input'],

 ['plus', 'plus', 'math'],
 ['minus', 'minus', 'math'],
 ['product', 'product', 'math'],
 ['division', 'division', 'math'],
 ['remainder', 'remainder', 'math'],
 ['random', 'random', 'random', [0, 100]],
 ['oneof', 'oneof', 'random', [0,100]],
 ['greater', 'greater', 'comp'],
 ['less', 'less', 'comp'],
 ['equal', 'equal', 'comp'],
 ['opar', 'opar', 'bracket1'],
 ['cpar', 'cpar', 'bracket2'],
 ['print', 'print', 'cmd'],

 ['wait', 'wait', 'cmd', 10],
 ['forever', 'forever', 'forever'],
 ['repeat', 'repeat', 'repeat', 4],
 ['if', 'if', 'if'],
 ['stop', 'stop', 'stopall'],
 ['vspace','vspace', 'vspace'],
 ['hspace','hspace', 'hspace']
];

Defs.special = [
 ['number', 'number', 'input'],
 ['global', 'global', 'input'],
 ['arg', 'arg', 'local'],
 ['setglobal', 'setglobal', 'cmd', 100],
 ['start', 'start0', 'hat0'],
 ['start0', 'start0', 'hat0'],
 ['start1', 'start1', 'hat1'],
 ['start2', 'start2', 'hat2'],
 ['hat0', "hat0-yellowhighlight", 'hat0'],
 ['hat1', "hat1-yellowhighlight", 'hat1'],
 ['hat2', "hat2-yellowhighlight", 'hat2'],
 ['procedure0', 'procedure0', 'cmd0'],
 ['procedure1', 'procedure1', 'cmd', 100],
 ['procedure2', 'procedure2', 'cmd2',[100, 100]]
];

	
Defs.getDefFor = function(type){
	for(var i=0;i<Defs.blocks.length;i++){
		if (Defs.blocks[i][0] == type) return Defs.blocks[i];
	}
	return null;
}

Defs.docks = {
cmd0:			[['flow',32,4],['flow',32, 44]],
cmd:			[['flow',32,4],['num',61,20],['flow',32,44]],
cmd2:			[['flow',32,4],['num',61,20],['num',61,60],['flow',32,84]],
vspace:		[['flow',32,4],['flow',32,64]],
hspace:		[['flow',34,10],['flow',105,10.5]],
input:		[['num',0,12],['numend',73,12]],
math:			[['numend',12,17],['num',32,17]],
random:		[['num',0,26],['num',16,27],['num',93,27],['numend',180,26]],
comp:			[['bool',0,17],['num',10,17],['num',101,17]],
bracket1: [['num',0,17],['num',30,17]],
bracket2: [['numend',13,17],['numend',41,17]],
forever:	[['flow',32,4],['flow',95,15],['unavailable',0,0]],
repeat:		[['flow',32,4],['num',61,20],['flow',105,47],['flow',32,89]],
'if':     [['flow',32,4],['bool',60.5,26.5],['flow',105,52],['flow',32,92]],
stopall:  [['flow',32,4],['unavailable',0,0]],
hat0:    	[['unavailable',0,0],['flow',46,54]],
hat1:			[['unavailable',0,0],['local',17,62],['flow',46,81]],
hat2:			[['unavailable',0,0],['local',17,62], ['local',17,88],['flow',46,107]],
arg:    	[['unavailable',0,0],['unavailable',0,0]],
local:    [['num',0,12],['numend',73,12]]
}

/////////////////////////
//
// Block Defining
//
/////////////////////////

Defs.blockinfo = {};

Defs.defineBlocks = function(){
	for(var i=0;i<Defs.blocks.length;i++) Defs.defineBlock.apply(null, Defs.blocks[i]);
	for(var i=0;i<Defs.special.length;i++) Defs.defineSpecial.apply(null, Defs.special[i]);
}

Defs.defineBlock = function(prim, name, docks, args){
	var res = new Object();
	var html = '<img src="assets/blocks/%0.svg">';
	html = html.replace('%0', name);
	res['html'] = html;	
	res['args'] = args;
	res['special'] =  false;
	res['docktype'] = docks;
	Defs.blockinfo[prim] = res;
}

Defs.defineSpecial = function(prim, name, docks, args){
	var res = new Object();	
	res['args'] = args;
	res['docktype'] = docks;
	res['special'] =  true;
	var html = '<img src="%0">';
	res['html'] = html;	
	Defs.blockinfo[prim] = res;
}

Defs.getText =function (b) {
	var str = Defs.svgs[b.alias]["str"];
	var key = b.type == "number" ? ">0</text>" : ">i</text>" ;
	return str.replace(key, ">"+ b.value+"</text>");
}
	


