/*
 PICO 2015
 */
 
PathTool = function() {};
PathTool.spo = require('svg-path-outline');
PathTool.endp;
PathTool.startp;
PathTool.values = {minx: 9999999, miny: 9999999, maxx: -9999999, maxy: -9999999};
PathTool.debug = false;

PathTool.getOriginal = function (svg) {
	var clippath = SVG.addChild(svg, 'clipPath', {id: "clip_image", clipPathUnits: "userSpaceOnUse"});
	var pathmask = SVG.pathElem(clippath, "pathmask_image","M0,0h700v560H0V0z");
	Turtle.svgGroup.setAttribute('clip-path', "url(#clip_image)");	
	return SVG.toString(svg);
}

PathTool.takeOutBackground = function (svg) {
	PathTool.removeBkg(svg);
	PathTool.cropToMinRectangle(svg);
	return SVG.toString(svg);		
}

PathTool.removeBkg = function (svg) {
	for (var i = 0; i <  svg.childElementCount; i++) {
		var elem = svg.childNodes[i];
		if (elem.id == "background") {svg.removeChild(elem); return;}
		if (elem.tagName.toLowerCase() == "g") PathTool.removeBkg(elem);
	}
}

PathTool.getCutout = function (settings, svg) {
	var el = SVG.top(700,560);
	PathTool.cutOut(settings, svg, el);
	PathTool.cropToMinRectangle(el);
	return SVG.toString(el);
}

PathTool.cutOut = function (settings, svg, el) {
	for (var i = 0; i <  svg.childElementCount; i++) {
		var elem = svg.childNodes[i];
		if (elem.id == "background") continue;
		switch (elem.tagName.toLowerCase()) {
			case "g":
				PathTool.cutOut(settings, elem, el);
				break;
			case "path":
			case "circle":
				var clone = SVG.getClone(elem);
 				var attr = {"fill": 'none', "stroke": settings.stroke, "stroke-width":  settings.pensize,
				"stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};
				for (var val in attr) clone.setAttribute(val, attr[val]);
				el.appendChild(clone);
				break;
		}	
	}
}

PathTool.getOutline = function (settings, svg, inside) {
	var el = SVG.top(700,560);
	var attr = {"fill": 'none', "stroke": '#ff0000', "stroke-width": settings.pensize, "d": "",  "stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};			
	PathTool.paths = SVG.addChild(el, 'path', attr);
	PathTool.lastpath = "";
	PathTool.getOutlineStroke(settings, svg, el, inside);
	PathTool.setAbsolutePath(el);
	PathTool.cropToMinRectangle(el);
	return SVG.toString(el);
}

PathTool.setAbsolutePath = function (svg) {
	for (var i = 0; i <  svg.childElementCount; i++) {
	var elem = svg.childNodes[i];
		if (elem.id == "background") continue;
		switch (elem.tagName.toLowerCase()) {
			case "g":
				PathTool.setAbsolutePath(elem);
				break;			
			case "path":
				SVG2Canvas.setAbsolutePath(elem);
				break;
			default:
				break;
		}	
	}
}

PathTool.getOutlineStroke = function (settings, svg, el, inside) {
	for (var i = 0; i <  svg.childElementCount; i++) {
	var elem = svg.childNodes[i];
		if (elem.id == "background") continue;
		switch (elem.tagName.toLowerCase()) {
			case "g":
				PathTool.getOutlineStroke(settings, elem, el, inside);
				break;			
			case "circle":
				var clone = SVG.getClone(elem);
 				var attr = {"fill": 'none', "stroke": settings.stroke, "stroke-width":  settings.pensize,
				"stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};
				for (var val in attr) clone.setAttribute(val, attr[val]);
				el.appendChild(clone);
				PathTool.lastpath = "";
				break
			case "path":
				var outline = "";		
				var d = elem.getAttribute('d');
				var w = elem.getAttribute("stroke-width")
				var insidestate =   !inside ?  false : elem.getAttribute('fill') == "none";
				insidestate = insidestate ? w > 4 : insidestate;
				var oldpath = PathTool.paths.getAttribute('d');
				if (!elem.getAttribute("stroke")) {
					PathTool.lastpath = d.substring(d.length - 1) == "z" ? d.substring(0, d.length - 1) : d;
					 PathTool.paths.setAttribute("d", oldpath + d);
					}
				else if (PathTool.lastpath != d){
				//	console.log ({inside: insidestate,	outside:	true});
					outline = PathTool.spo(d, w/2 , {inside: insidestate,	outside:	true});	
					PathTool.paths.setAttribute("d", oldpath + outline);
				}
				break;
		}	
	}
}

PathTool.cropToMinRectangle = function (elem) {
	if (PathTool.debug) {
		PathTool.mysvg = elem;
		PathTool.outpath = "";
		PathTool.n = 0;
	}
	PathTool.values = {minx: 9999999, miny: 9999999, maxx: -9999999, maxy: -9999999, strokemax: 0};
	PathTool.findDimensions(elem); 
	PathTool.expandValuesBy (PathTool.values.strokemax*2, 5);
	
	if (PathTool.debug) {
		var attr = {"fill": 'none', "stroke": '#0000ff', "stroke-width": 1, "d": PathTool.outpath,  "stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};			
		SVG.addChild(elem, 'path', attr);
	}
	SVG.topSetSize (elem, PathTool.values.maxx - PathTool.values.minx, PathTool.values.maxy - PathTool.values.miny);
	PathTool.shiftBy(elem, -PathTool.values.minx, -PathTool.values.miny);
}

PathTool.expandValuesBy = function (delta, offset){
	var val = (delta +  offset);
	PathTool.values.minx -= val
	PathTool.values.miny -= val;
	PathTool.values.maxx += val;
	PathTool.values.maxy += val;
	PathTool.values.minx = Math.max(0, PathTool.values.minx);
	PathTool.values.miny = Math.max(0, PathTool.values.miny);
	PathTool.values.maxx = Math.min(700, PathTool.values.maxx);
	PathTool.values.maxy = Math.min(560, PathTool.values.maxy);	
}

PathTool.shiftBy = function (svg, dx, dy) {
	for (var i = 0; i <  svg.childElementCount; i++) {
		var elem = svg.childNodes[i];
		elem.setAttribute("transform", "matrix( 1 0 0 1 " + dx + " " + dy+")");
	}
}

PathTool.findDimensions = function (svg) {
	for (var i = 0; i <  svg.childElementCount; i++) {
		var elem = svg.childNodes[i];
		if (elem.id == "background") continue;
		switch (elem.tagName.toLowerCase()) {
			case "g":
				PathTool.findDimensions(elem);
				break;
			case "circle":
				var r =  Number(elem.getAttribute('r'));
				var cx =  Number(elem.getAttribute('cx'));
				var cy =  Number(elem.getAttribute('cy'));
				PathTool.adjustValues (cx-r, cy-r, r+cx, r+cy);
				break;
			case "path":
				PathTool.setDimensions (elem.getAttribute('d'));		
				PathTool.values.strokemax = Math.max (Number(elem.getAttribute("stroke-width")/2),PathTool.values.strokemax);
				break;
		}	
	}
}


PathTool.adjustValues = function (minx, miny, maxx, maxy){
	PathTool.values.minx = Math.max(0, Math.min(PathTool.values.minx, minx));
	PathTool.values.miny = Math.max(0, Math.min(PathTool.values.miny, miny));
	PathTool.values.maxx = Math.min(700, Math.max(PathTool.values.maxx, maxx));
	PathTool.values.maxy = Math.min(560, Math.max(PathTool.values.maxy, maxy));	
//	console.log ("PathTool.adjustValues", maxx, maxy, PathTool.values.maxx, PathTool.values.maxy);	
}

PathTool.setDimensions=function(d){
	var commands = PathTool.getCommandList(d);
	if (!commands) return d;
	for (var i = 0; i < commands.length ; i++) PathTool.findPathsize(commands[i]);
}

PathTool.findPathsize=function(cmd){
	var key = cmd[0];
	//console.log (key);
	if (!PathTool.dispatchSizeCmd[key]) console.log (key +" missing");
	else PathTool.dispatchSizeCmd[key](cmd);
}

PathTool.closePathSize=function(cmd){}


PathTool.startSizePath= function(cmd){
	PathTool.endp = {x: cmd[1], y: cmd[2]};
	PathTool.startp = PathTool.endp;
	PathTool.adjustValues(cmd[1], cmd[2], cmd[1],cmd[2]);
}

PathTool.lineSize = function(cmd){
	var pt =  {x: cmd[1], y: cmd[2]};	
	PathTool.adjustValues(cmd[1], cmd[2], cmd[1],cmd[2]);
	PathTool.endp = pt;
}


 PathTool.tt  = function(name){
	var svg = SVG.top(700,560);
	var attr = {"fill": 'none', "stroke": '#ff0000', "stroke-width": 1, "d": "",  "stroke-miterlimit": 10, "stroke-linecap": "round", "stroke-linejoin": "round"};		
	attr ["d"] ="M473 306A 80 80 0 1 1 349.9547969271232 220.45658026822537";
	SVG.addChild(svg, 'path', attr);
	attr ["d"] ="M473 306A 80 80 0 0 1 349.9547969271232 220.45658026822537";
	SVG.addChild(svg, 'path', attr);	
		
	attr ["d"] ="M473 306A 80 80 0 0 0 349.9547969271232 220.45658026822537";
	SVG.addChild(svg, 'path', attr);	

	attr ["d"] ="M473 306A 80 80 0 1 0 349.9547969271232 220.45658026822537";
	SVG.addChild(svg, 'path', attr);		

	var str = PathTool.getCutout(Maker.modes["stroke"], svg);
	var filename = "/Users/paula/Downloads/TAConverterTest/"+ name + ".svg";
	main.saveProject(filename, str); 
}

PathTool.arcSize = function(cmd){
	var pt =  {x: cmd[6], y: cmd[7]};	
	PathTool.adjustValues(cmd[6], cmd[7], cmd[6],cmd[7]);
	var v1 = Vector.diff(pt, PathTool.endp);
	var heading = getAngle( 90 + fromDelta(v1));		
	// in path
	var b = cmd[1];
	var c = cmd[2];
	var r = b;
	var angles = PathTool.getAngles(Vector.len(v1),b,c);
	if (angles.A.toString() == 'NaN') angles = {A: 0, B:0, C:0};
	// in path
	var flag = cmd[5] == 0;
	var isLarge = cmd[4] == 1;
	
	var headingtocenter = getState(!flag, isLarge, heading, angles); // flag  && !isLarge ? getAngle (heading - angles.B) : getAngle (heading + angles.B) ;
	function getState(cw, islarge, h, angles)  {
		//console.log(islarge,cw);
		if (islarge&&!cw) return getAngle (h + angles.B);
		if (islarge&&cw) return (h - angles.B);
		if (!islarge&&cw) return (h + angles.B);
		else return (h - angles.B);
	}
	
	var center =  PathTool.getCoor(PathTool.endp, headingtocenter,  r);
	
	var sh = getAngle(90 + fromDelta(Vector.diff(center, PathTool.endp)));		
	var eh = getAngle(90 + fromDelta(Vector.diff(center, pt)));		

	// debugging
	var perp = PathTool.getPerp(PathTool.endp, pt);
	perp = flag ? perp : (perp + 180).mod(360);
	if (PathTool.debug) {
		PathTool.n++;
		var attr = {"fill": '#ffcc00', 'cx':center.x, 'cy': center.y, 'r': 5 , id:"name"+PathTool.n};			
		SVG.addChild(PathTool.mysvg, 'circle', attr);
		PathTool.n++;
		attr = {"fill": '#0093ff', 'cx':pt.x, 'cy': pt.y, 'r': 5 , id:"name"+PathTool.n};			
		SVG.addChild(PathTool.mysvg, 'circle', attr);
		PathTool.n++;	
		attr = {"fill": '#9300ff', 'cx':PathTool.endp.x, 'cy': PathTool.endp.y, 'r': 5 , id:"name"+PathTool.n};			
		SVG.addChild(PathTool.mysvg, 'circle', attr);
		PathTool.outpath += "M"+PathTool.endp.x+","+PathTool.endp.y;
		PathTool.outpath += "L"+center.x+","+center.y;
		PathTool.outpath += "L"+pt.x+","+pt.y;
		PathTool.outpath += "L"+PathTool.endp.x+","+PathTool.endp.y;	
		PathTool.n++;
		var pp = Vector.sum (center, PathTool.fromPolar(perp, r));
		attr = {"fill": '#dddddd', 'cx':pp.x, 'cy': pp.y, 'r': 5 , id:"name"+PathTool.n};			
		SVG.addChild(PathTool.mysvg, 'circle', attr);
	}
	
	var values = {center: center, s: sh, e: eh, r: r, CCW: flag, large: cmd[4] == 0}
	PathTool.getMinMaxFromArc (values);	
	function fromDelta(pt) {return Number((Math.atan2(pt.y, pt.x) * 180 / Math.PI).toFixed(12))};
	function getAngle (a) {return (a < 0 ? 360 + a : a).mod(360);}
	PathTool.endp =  {x: cmd[6], y: cmd[7]};	
}
          

PathTool.getMinMaxFromArc = function (v){
	for (var a = 0; a < 360; a+=90) {
		if (PathTool.inAngleRange(a, v)) PathTool.plotPos(v.center, a+180, v.r);
	}
}

PathTool.inAngleRange = function (a, v){
	var delta = Math.abs(v.s - v.e);
	delta =  delta  < 180 ? v.large ? 360 - delta : delta  : v.large ?  delta : 360 - delta ;
	var starth = v.CCW ? v.e : v.s;
	var endh = v.CCW ? v.s : v.e;
	if (endh < starth) {
		var isbad = ((a + 360) > (endh + 360));
		return !isbad;
	}
	else if (a > endh) return false;
	if (a < starth) return false;
	return true;
}


PathTool.plotPos = function(center, angle, r){
	var pt1 =  PathTool.getCoor(center, angle,  r); //Vector.sum (center, PathTool.fromPolar( (angle+180).mod (360),  r));
	var color = '#ff0000';
	switch (angle.mod (360)){
		case 0: color = '#00ff00'; break;
		case 90: color = '#0000ff'; break;
		case 270: color = '#00FFff'; break;
	}	

	if (PathTool.debug) {
		PathTool.n++;
		console.log (pt1,"--->", angle.mod(360),r, color, "name"+PathTool.n);
		var attr = {"fill":  color, 'cx':pt1.x, 'cy': pt1.y, 'r': 5, id:"name"+PathTool.n};									
		SVG.addChild(PathTool.mysvg, 'circle', attr);
	}
	PathTool.adjustValues(pt1.x, pt1.y, pt1.x, pt1.y);
}

PathTool.fromPolar = function (a, radius) {return {x: radius * cosdeg(a), y: radius * sindeg(a)};}       
PathTool.getCoor = function(pt, a, dist) {return {x: pt.x +dist*sindeg(a), y: pt.y - dist*cosdeg(a)};}	

PathTool.dispatchSizeCmd = {'M': PathTool.startSizePath, "L": PathTool.lineSize,'A': PathTool.arcSize, "z": PathTool.closePathSize, "Z": PathTool.closePathSize};


////////////////////////////////////////////////////
// Relative to Absolute Path conversion
///////////////////////////////////////////////////

PathTool.getSVGcommands=function(shape){return PathTool.getCommandList(shape.getAttribute("d"));}

PathTool.getCommandList=function(d){
	if (!d) return null;
	var commands = d.match(/[A-DF-Za-df-z][^A-Za-df-z]*/g);
	if (!commands) return null;
	var res =[];
	for (var i = 0; i < commands.length ; i++)  {	
		var cmd = commands[i];
		var ct = cmd.charAt(0);	
		var cmddata = (ct.toLowerCase() == "z") ? [] : PathTool.splitNumericArgs(cmd.substr(1, cmd.length));
		cmddata.unshift(ct);
		res.push(cmddata);
	}
	return res;
}

PathTool.splitNumericArgs=function(str) {
	var res=[];
	if (!str) return res;
	var list = str.match(/(?:\+|-)?\d+(?:\.\d+)?(?:e(?:\+|-)?\d+)?/g);
	for (var i = 0; i < list.length ; i++) res.push(Number(list[i]));
	return res;
}

PathTool.arrayToString=function(res){		
	var str="";
	for (var i =0 ; i < res.length; i++) {
		var cmd = res [i];
		str += cmd[0];
		if (cmd.length > 1) {
			cmd.shift();
			str += cmd.toString();
		}
	}
	return str;	
}

PathTool.getAngles = function (a, b, c){
		var cosa = ((b * b) + (c * c) - (a * a)) / ( 2 * b * c); // turtle angle comand
		var cosb = ((c * c) + (a * a) - (b * b )) / ( 2 * c * a); // the other side
		var cosc = ((a * a) + (b * b) - (c * c)) / ( 2 * a * b); // one side
		return {A: cos2degree(cosa),  C: cos2degree(cosc), B: cos2degree(cosb)};
}

function cos2degree(val) { return Number(deg(Math.acos(val)).toPrecision(12));}

PathTool.getPerp = function (before, here){ 
	var v1 = Vector.diff (here, before);
	return (((Math.atan2(v1.y, v1.x) * 180) / Math.PI) + 90).mod(360); 
}

