/* © 2017 Playful Invention Company */

Runtime = function() {};

Runtime.thisBlock = undefined;
Runtime.xmax=700;
Runtime.ymax=560;
Runtime.waitendtime = undefined;
Runtime.stack = [];
Runtime.boxes = {box1: 0, box2: 0, box3: 0};
Runtime.procs = {};
Runtime.lastrun= undefined;
Runtime.timeout = undefined;
Runtime.flag = false;

/////////////////////////
//
// State Machine
//
/////////////////////////

Runtime.runStack = function(b){
	Turtle.pathCount = 0;
	Runtime.lastrun = b;
	Runtime.stack = new Array();
	Runtime.thisBlock = b;
	Turtle.startseed = Turtle.seed;
	Runtime.runSome();
}

Runtime.isRunning = function (){return Runtime.stack.length>0||Runtime.thisBlock!=undefined;}

Runtime.stopStack = function(){
	Runtime.stack = new Array();
	Runtime.thisBlock = undefined;	
}

Runtime.runSome = function(){
	var scale = 920/700;
	Maker.ctx.scale(scale, scale);
	var endtime= now()+50;
	for(var i=0;i<500;i++){
		if(now()>endtime) break;
		while (Runtime.thisBlock==undefined){
			if(Runtime.stack.length==0) break;
			Runtime.stack.pop()();
		}
		if (Runtime.thisBlock==undefined) break;
		var b = Runtime.thisBlock;
	//	console.log (b.type);
		Runtime.thisBlock = Runtime.thisBlock.connections[Runtime.thisBlock.connections.length-1];
		if (!b.fcn) console.log (b.type, "not defined");
		else b.fcn(b);
	}
	Turtle.move();
	if (Runtime.stack.length>0||Runtime.thisBlock!=undefined) Runtime.timeout = setTimeout(Runtime.runSome, 20);
	else {
		Turtle.drawSVG();
	}
	Maker.ctx.scale(1/scale, 1/scale);
}

Runtime.isActive = function(){
	return (Runtime.stack.length>0||Runtime.thisBlock!=undefined);
}

Runtime.getnum = function(p,dockn){
	var b = p.connections[dockn];
	if (!b) return Runtime.getDefaultArg(p, dockn);
	return Runtime.evalNumberBlock(b);
}

Runtime.evalNumberBlock = function(b){
	var n = b.fcn(b);
	while(true){
		var infixop = Runtime.numAfter(b);
		if(infixop==undefined) return n;
		if(infixop.type=='cpar') return n;
		b = infixop.connections[1];
		if(b==undefined) return infixop.fcn(n,0);
		else n=infixop.fcn(n,b.fcn(b));
	}
}

Runtime.getDefaultArg = function(b,dockn){
	var arg = b.info.args;
	if(typeof(arg)=='number') return arg;
	if(typeof(arg)=='object') return arg[dockn-1];
	return 0;
}

Runtime.numAfter = function(b){
	var opened = 1;
	if(b.type!='opar') return b.connections[b.connections.length-1];
	while(true){
		b = b.connections[b.connections.length-1];
		if(b==undefined) return b;
		if(b.type=='opar') opened++;
		if((b.type=='cpar')&&(opened--==1)) return b.connections[1];
	}
}

Runtime.getbool = function(p,dockn){
	var b = p.connections[dockn];
	if (!b) return false;
	return b.fcn(b);
}

Runtime.ifDone = function(){Runtime.thisBlock=Runtime.stack.pop();}

Runtime.repeatAgain = function(){
	var b = Runtime.stack.pop();
	var n = Runtime.stack.pop();
	n--;
	if(n>0){
		Runtime.stack.push(n);
		Runtime.thisBlock = b;
		Runtime.stack.push(Runtime.thisBlock);
		Runtime.stack.push(Runtime.repeatAgain);
	}
	else Runtime.thisBlock=Runtime.stack.pop();
}

Runtime.foreverAgain = function(){
	Runtime.thisBlock = Runtime.stack[Runtime.stack.length-1];
	Runtime.stack.push(Runtime.thisBlock);
	Runtime.stack.push(Runtime.foreverAgain);
}

Runtime.procDone = function(){
	Runtime.thisBlock = Runtime.stack.pop();
	var argn = Runtime.stack.pop();
	for(var i=0;i<argn;i++){
		var v = Runtime.stack.pop();
		var val = Runtime.stack.pop();
		Runtime.boxes[v] = val;
	}
}
