/* © 2017 Playful Invention Company */

/////////////////////////
//
//Save
//
/////////////////////////

SVG = function() {};
SVG.svgns =  "http://www.w3.org/2000/svg";

SVG.toObject= function(str){
	str.replace(/>\s*</g,'><');
	var xmlDoc = (new DOMParser()).parseFromString(str, "text/xml");
	var node = document.importNode(xmlDoc.documentElement, true);
	return node;
}
	
SVG.getClone = function(svg){return  SVG.toObject(SVG.toString (svg));}

///////////////////////////////
// SVG Element Creation Tools
///////////////////////////////

SVG.top = function (w,h){
	var el = document.createElementNS(SVG.svgns,"svg");
	el.setAttributeNS(null, 'version', 1.1);
	el.setAttribute("xml:space","preserve");
	el.setAttribute('xmlns:xlink',"http://www.w3.org/1999/xlink");
	el.setAttributeNS(null,'width',w);
	el.setAttributeNS(null, 'height', h);
	el.setAttributeNS(null, 'viewBox',  '0 0 '+ w +' '+ h);
	return el;
}

SVG.topSetSize = function (el, w,h){
	el.setAttributeNS(null,'width',w);
	el.setAttributeNS(null, 'height', h);
	el.setAttributeNS(null, 'viewBox',  '0 0 '+ w +' '+ h);
	return el;
}

SVG.group = function(parent, id){
	var el = document.createElementNS(SVG.svgns,"g");
	if (id) el.setAttribute("id", id);
	if (parent) parent.appendChild(el);
	return el;
}

SVG.pathElem = function(parent, id,d, fill, stroke){
	var el = document.createElementNS(SVG.svgns,"path");
	if (id) el.setAttribute("id", id);
	if (parent) parent.appendChild(el);
	if (d) el.setAttribute("d", d);
	if (fill) el.setAttribute("fill", fill);
	if (stroke) el.setAttribute("stroke", fill);
	return el;
}

SVG.addChild = function (div, type, attr){
	var	shape = document.createElementNS(SVG.svgns, type);
	for (var val in attr) shape.setAttribute(val, attr[val]);
	if (div) div.appendChild(shape);
	return shape;
}

///////////////////////
// Other Tools
//////////////////////

SVG.stringToImage =  function (str){
	var img = new Image();
	img.src =  "data:image/svg+xml;base64," + btoa(unescape(encodeURIComponent(str)));
	return img;
}

SVG.toString = function (svg){
	var str ='<?xml version="1.0" encoding="utf-8"?>\n'
	str += new XMLSerializer().serializeToString(svg);			
	return str.replace("&amp;","&");
}
